SystemOrganization addCategory: #'TP Integrador'!

Object subclass: #ConEntrenador
	instanceVariableNames: 'entrenador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 21:37'!
entrenador
^entrenador.! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 17:42'!
miEntrenadorTieneAlMenosDosMasVivos
^(self entrenador) tenesAlMenosDosMasVivos ! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 18:00'!
noSoyElMasGroso 
^((self entrenador quienEsElMasGroso)=self)not.! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 17:45'!
tePuedenSacrificar 

^(self miEntrenadorTieneAlMenosDosMasVivos and:[self noSoyElMasGroso]). 

"A la coleccion p right parenthesis expected ->okemones le cambie el nombre a pokemonesConEntr right parenthesis expected ->enador (por lo que entendi creo que era eso, pero deje el significado mas claro con el nombre) "

"Le agregue la variable local unEntrenador, para que NADA MAS se cuenten todos los pokemones que tiene el entrenador del pokemon al que se le pregunta si se lo puede sacrificar. De esta forma se evita que la coleccion pokemones incluya a TODOS los pokemones de TODOS los entrenadores, no se si me explico. Capaz estaba bien hecho antes (sin la variable local), o capaz con esto nuevo que le puse se soluciona eso que jodia en los test. Miralo un toque con esto que te digo que despues lo vemos juntos si queres loca."! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:55'!
tieneEntrenador
^true.! !

!ConEntrenador methodsFor: 'as yet unclassified' stamp: 'juan 10/24/2013 20:57'!
tuNuevoEntrenadorEs:unEntrenador

entrenador:=unEntrenador.! !

Object subclass: #Confundido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Confundido class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:43'!
cuantoPoderSumas 
^40. ! !

!Confundido class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:52'!
sosUnaCondicionNoEspecial
^false.! !

!Confundido methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 21:03'!
sePuedeMover:unPokemon
^Moneda flip
ifFalse:[ErrorConfundido signal. unPokemon teAutoGolpeas ]. 

"El enunciado dice que si intenta moverse y no puede, recien ah se autogolpea cabeza, no que esta re duro y de una no se puede ni mover jaja. Ademas habiendo jugado una bocha de veces al gameboy calculo que quisieron ponerlo igual a como es en el jueguito posta: tira la moneda, si sale cara ataca todo bien, si sale seca se pega a el mismo el enfermito."

"Lo cambio porque antes deca self teAutoGolpeas, y aca no esta definido ese mtodo, sino en el pokemon que se golpeara. Como tambin me genera un conflicto en Dormido, lo cambio pasandole por parametro el pokemon"! !

!Confundido methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 21:21'!
sosUnaCondicionNoEspecial 
^false.! !

Object subclass: #Dormido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Dormido class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:44'!
cuantoPoderSumas 
^50. ! !

!Dormido class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:51'!
sosUnaCondicionNoEspecial
^false.! !

!Dormido methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 22:08'!
sePuedeMover:unPokemon
^Moneda flip ifTrue:[unPokemon condicion:Normal. ^true.]
ifFalse:[ErrorDormido signal]. 

"le cambie el orden a la parte de ifTrue. Fijate que la version de antes no ponia al self en color (lo tomaba como nose, algo raro, y para separar sentencias (o sea si queres hacer varias cosas) se separan con un punto segun la guia de lenguajes. El and se usa nada mas para comparar booleanos)"! !

!Dormido methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 21:22'!
sosUnaCondicionNoEspecial 
^false.! !

Object subclass: #Entrenador
	instanceVariableNames: 'pokemones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Entrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 19:18'!
agregaA:unPokemon
self pokemones add:unPokemon. ! !

!Entrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 17:25'!
initialize
pokemones:=Bag new. ! !

!Entrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 17:25'!
pokemones 
^pokemones. ! !

!Entrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 18:01'!
quienEsElMasGroso

^ self pokemones detectMax:[:unPokemon| unPokemon cuantaGrositudTenes].! !

!Entrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 17:43'!
tenesAlMenosDosMasVivos 
^(self pokemones count:[:unPokemon|(unPokemon estasVivo)])>=2.! !

Object subclass: #Medicina
	instanceVariableNames: ''
	classVariableNames: 'cantidadQueCura'
	poolDictionaries: ''
	category: 'TP Integrador'!

!Medicina methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:34'!
aplicarEn:unPokemon
unPokemon curate:cantidadQueCura.! !

!Medicina methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 18:51'!
aplicarEn:unPokemon yTelaTiro: unEntrenador
(unPokemon tuEntrenadorEs:unEntrenador) ifTrue:[unPokemon curate:cantidadQueCura].! !

!Medicina methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 21:34'!
cantidadQueCura:unaCantidad
cantidadQueCura:=unaCantidad. ! !

Object subclass: #MedicinaEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MedicinaEspecial methodsFor: 'as yet unclassified' stamp: 'juan 11/15/2013 21:07'!
aplicarEn:unPokemon
unPokemon condicion:Normal new.! !

!MedicinaEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 18:51'!
aplicarEn:unPokemon yTelaTiro:unEntrenador
(unPokemon tuEntrenadorEs:unEntrenador) ifTrue:[unPokemon condicion:Normal new].! !

Object subclass: #Movimiento
	instanceVariableNames: 'usosDisponibles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:11'!
estasDisponible
^usosDisponibles >0.! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'juan 11/16/2013 21:29'!
sosCurativo

^(self class=MovimientoCurativo).! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 21:04'!
sosDanino 

^(self class=MovimientoDanino).! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:14'!
unUsoMenos 
usosDisponibles:=usosDisponibles -1.! !

!Movimiento methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 18:49'!
usosDisponibles:unosUsos
usosDisponibles:=unosUsos. ! !

Movimiento subclass: #MovimientoCurativo
	instanceVariableNames: 'puntosACurar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 18:36'!
aplicarEfectoA: otroPokemon
otroPokemon curate:puntosACurar.! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'juan 11/15/2013 20:44'!
convieneQue:pokemonAtacante TeUseContra: pokemonAtacado
^(pokemonAtacante estasMedioMuerto) and:[(pokemonAtacante esDeAlguien tePuedenSacrificar)not]. 
! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:35'!
cuantoPoderSumas 
^puntosACurar. ! !

!MovimientoCurativo methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:44'!
puntosACurar:unaCantidad
puntosACurar:=unaCantidad.! !

Movimiento subclass: #MovimientoDanino
	instanceVariableNames: 'puntosDeDao'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 16:39'!
aplicarEfectoA:otroPokemon
otroPokemon teDaaron:(self puntosDeDao).

"Le puse un self adelante a puntosDeDao, sino quedaba en azul como si fuera una variable y no un atributo".! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 21:04'!
convieneQue:pokemonAtacante TeUseContra:pokemonAtacado
^((self derrotasPorMenosDe50A:pokemonAtacado) | (self sosMovimientoDaninoDe:pokemonAtacante YLosDemasNoDerrotanA:pokemonAtacado) | (self noDerrotasA:pokemonAtacado)). ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:46'!
cuantoPoderSumas 
^puntosDeDao *2.! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'juan 11/15/2013 20:33'!
derrotasA:unPokemon

^ self puntosDeDao > unPokemon tusPuntosDeVida. ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:56'!
derrotasPorMenosDe50A:otroPokemon
^ (self derrotasA:otroPokemon) and:[(self puntosDeDao - otroPokemon tusPuntosDeVida)<50].! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 21:34'!
noDerrotasA:unPokemon
^self puntosDeDao < unPokemon tusPuntosDeVida. ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 17:41'!
puntosDeDao 
^puntosDeDao. ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 19:47'!
puntosDeDao:unaCantidad
puntosDeDao:=unaCantidad. ! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 21:06'!
sosMenosPoderosoQue:otroAtaque

^(puntosDeDao < otroAtaque puntosDeDao) .! !

!MovimientoDanino methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 21:05'!
sosMovimientoDaninoDe:unPokemon YLosDemasNoDerrotanA:otroPokemon 
|movimientosDaninos|
movimientosDaninos:=unPokemon movimientos select:[:unMovimiento|unMovimiento sosDanino].
^movimientosDaninos anySatisfy:[:movimiento| (movimiento derrotasA:otroPokemon)and: [movimiento sosMenosPoderosoQue:self]].! !

Movimiento subclass: #MovimientoEspecial
	instanceVariableNames: 'condicionEnLaQueVaAQuedar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!MovimientoEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:47'!
aplicarEfectoA:otroPokemon
otroPokemon condicion:(self condicionEnLaQueVaAQuedar).! !

!MovimientoEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:45'!
condicionEnLaQueVaAQuedar 
^condicionEnLaQueVaAQuedar. ! !

!MovimientoEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:43'!
condicionEnLaQueVaAQuedar:unaCondicion
condicionEnLaQueVaAQuedar:=unaCondicion. ! !

!MovimientoEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 16:58'!
convieneQue:pokemonAtacante TeUseContra:pokemonAtacado
^((pokemonAtacado cuantaGrositudTenes > (pokemonAtacante cuantaGrositudTenes *2)) and:[pokemonAtacado noEstasAfectadoPorUnaCondicion]).! !

!MovimientoEspecial methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:49'!
cuantoPoderSumas 
^((self condicionEnLaQueVaAQuedar) cuantoPoderSumas).! !

Object subclass: #Normal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Normal class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:52'!
sosUnaCondicionNoEspecial
^true.! !

!Normal methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 18:33'!
sePuedeMover:unPokemon
^true. ! !

!Normal methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/15/2013 22:25'!
sosUnaCondicionNoEspecial
^true.! !

Object subclass: #Paralizado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Paralizado class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:44'!
cuantoPoderSumas 
^30.! !

!Paralizado class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 21:20'!
sosUnaCondicionNoEspecial 
^false.! !

!Paralizado methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 22:11'!
sePuedeMover:unPokemon 

^ Moneda flip ifFalse: [ErrorParalizado signal. ^false.]
! !

!Paralizado methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 21:21'!
sosUnaCondicionNoEspecial 
^false.! !

Object subclass: #Pokebola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Pokebola methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 19:17'!
aplicarEn:unPokemon yTelaTiro:unEntrenador

unPokemon tePuedenTirarUnaPokebola. 

unPokemon tePuedeAtrapar:unEntrenador.




"Le saque un ^ que habia adelante de --> unPokemon tieneEntrenador "

"Le agregue un pokemones add:unPokemon asi va agregando a una coleccion cada pokemon que va teniendo entrenador (para hacer punto 6b)"! !

Object subclass: #Pokemon
	instanceVariableNames: 'movimientos puntosDeVida puntosDeVidaMax condicion experiencia ganadores esDeAlguien losQueMeGanaron'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/15/2013 18:41'!
agregarExperiencia: unaCantExperiencia

experiencia:= experiencia + unaCantExperiencia. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/17/2013 20:50'!
condicion
^condicion.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:11'!
condicion:unObjeto
condicion:=unObjeto. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/26/2013 23:34'!
cuantaGrositudTenes
^self nivel * self sumaPoderMovimientos. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/15/2013 17:56'!
curate:unosPuntos
puntosDeVida:=(puntosDeVida + unosPuntos) min: puntosDeVidaMax.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 21:58'!
esDeAlguien 
^esDeAlguien. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/24/2013 21:00'!
esDeAlguien:unObjeto
esDeAlguien:=unObjeto! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/15/2013 19:24'!
estasMedioMuerto

^ puntosDeVida <= (puntosDeVidaMax / 2).! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/15/2013 18:35'!
estasVivo
^puntosDeVida >0.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 17:15'!
experiencia 
^experiencia. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:09'!
experiencia:unaCantidad
experiencia:=unaCantidad.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 16:35'!
experienciaASumar
^(self cuantaGrositudTenes / (self losQueMeGanaron) size). ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 16:49'!
ganadores
^ganadores. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 20:51'!
initialize
movimientos:=Set new.
self condicion:Normal new.
losQueMeGanaron:=Set new. 
self experiencia:0. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/16/2013 21:29'!
losQueMeGanaron 

^losQueMeGanaron.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 21:05'!
luchaCon:unMovimiento contra:otroPokemon
self tePodesMover ifTrue:
[self movimiento:unMovimiento contra:otroPokemon.
self estasVivo ifTrue:[(otroPokemon losQueMeGanaron) add:self]].



"Le saque un ^ que habia adelante de otroPokemon tusPuntosDeVida porque creo que no hace falta que devuelva nada."

"Le cambie el signo de <=0 por un >=0 porque creo que ese renglon lo que quiere decir es que: si el pokemon ataca y lo deja al otro bicho en 0 o con algo de vida, que se lo agregue a la coleccion de ganadores, no?"

"El ifFalse:[self error: 'No gano todavia'] que carago es? jaja, o sea entiendo qu es, pero lo pide en algn lado del enunciado? Me parece que lo tengo como el orto jajaja despues acordate de contarme que onda."! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/16/2013 21:28'!
movimiento:unMovimiento contra:otroPokemon
unMovimiento sosCurativo ifTrue: [unMovimiento aplicarEfectoA:self]
ifFalse:[unMovimiento aplicarEfectoA:otroPokemon].
unMovimiento unUsoMenos. 
! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 20:28'!
movimientos
^movimientos.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 20:40'!
movimientos:unaColeccion
movimientos:=unaColeccion. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 20:51'!
movimientosConvenientesContra:otroPokemon
movimientos select:[:movimiento|movimiento convieneQue:self TeUseContra:otroPokemon].! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/15/2013 18:31'!
movimientosDisponibles
^ self movimientos select:[:movimiento|movimiento estasDisponible]. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 19:51'!
nivel
^(experiencia nthRoot:7) floor. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 21:22'!
noEstasAfectadoPorUnaCondicion
^(self condicion) sosUnaCondicionNoEspecial. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 16:31'!
premiaALosGanadores
(self estasVivo)not ifTrue:[losQueMeGanaron do:[:unPokemon|unPokemon salisteGanadorContra:self]].

! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 16:36'!
salisteGanadorContra:unPokemon
self estasVivo ifTrue:[self agregarExperiencia:(unPokemon experienciaASumar)]. 

"Le saque un ^ que habia adelante de self tusPuntosDeVida porque creo que no es necesario devolver nada (acordate que con do no me importa lo que devuelve, sino que lo haga y nada mas (no importa el efecto creo que decian los ayudantes) )."! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 17:30'!
soloUnMovimientoLoDerrotaA:unPokemon 
^self puntosDeDao >=50 and:[self movimientosDisponibles count:[:movimiento|movimiento class=MovimientoDanino and:[movimiento puntosDeDao > unPokemon puntosDeVida]]=0]. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 18:26'!
sumaPoderMovimientos 
^self movimientos sum:[:movimiento|movimiento cuantoPoderSumas]. 

"Le agregue un self adelante de movimientos, sino quedaba como que era una variable y en realidad es un atributo, creo"

! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/15/2013 18:44'!
teAutoGolpeas 

self teDaaron:30. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 16:31'!
teDaaron:unosPuntos
puntosDeVida:=(puntosDeVida -unosPuntos)max:0 . ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 21:02'!
tePodesMover 
^(condicion sePuedeMover:self).! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 19:18'!
tePuedeAtrapar:unEntrenador
^(self esDeAlguien)tieneEntrenador  ifTrue:[EstePokemonYaTieneDuenioError signal]
							     ifFalse:[self esDeAlguien:(ConEntrenador new).
								(self esDeAlguien) tuNuevoEntrenadorEs:unEntrenador. 
										(unEntrenador)agregaA:self].! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/16/2013 19:13'!
tePuedenTirarUnaPokebola 
^self estasMedioMuerto ifFalse:[ErrorDebesDebilitarloMas signal].! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/18/2013 20:32'!
tuEntrenadorEs:unEntrenador

^((self esDeAlguien entrenador) = unEntrenador).! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 11/19/2013 22:37'!
tuNuevoEntrenadorEs:unEntrenador
(self esDeAlguien)tuNuevoEntrenadorEs:unEntrenador.
unEntrenador agregaA:self. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/23/2013 00:15'!
tusPuntosDeVida
^puntosDeVida.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 18:48'!
tusPuntosDeVida:unosPuntos
puntosDeVida:=unosPuntos. ! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'juan 10/23/2013 00:19'!
tusPuntosDeVidaMax
^puntosDeVidaMax.! !

!Pokemon methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 18:48'!
tusPuntosDeVidaMax:unosPuntos
puntosDeVidaMax:=unosPuntos. ! !

Object subclass: #SinEntrenador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!SinEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 19:19'!
tePuedenSacrificar 
^false.! !

!SinEntrenador methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/24/2013 16:55'!
tieneEntrenador
^false.! !

Error subclass: #ErrorConfundido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!ErrorConfundido methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 20:33'!
signal

"ErrorConfundido  signal: 'El pokemon esta confundido!!'."! !

Error subclass: #ErrorDebesDebilitarloMas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!ErrorDebesDebilitarloMas class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 21:20'!
signal
Error signal:'No esta medio muerto'. ! !

!ErrorDebesDebilitarloMas methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 20:34'!
signal

"ErrorDebesDebilitarloMas signal: 'Debes debilitar mas al pokemon para capturarlo!!'."! !

Error subclass: #ErrorDormido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!ErrorDormido methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 20:34'!
signal

"ErrorDormido signal:'Este pokemon esta dormido!!'"! !

Error subclass: #ErrorParalizado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!ErrorParalizado methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 20:34'!
signal

"ErrorParalizado signal:'Este pokemon esta paralizado!!'"! !

Error subclass: #EstePokemonYaTieneDuenioError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!EstePokemonYaTieneDuenioError class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 19:50'!
signal
Error signal: 'No puedes robar este pokemon. Ya tiene dueo!!'! !

!EstePokemonYaTieneDuenioError methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 20:34'!
signal

"^EstePokemonYaTieneDuenioError signal: 'No puedes robar este pokemon. Ya tiene dueo!!'."! !

Error subclass: #NoTePodesMoverError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador'!

!NoTePodesMoverError class methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 21:12'!
signal
NoTePodesMoverError signal:'No te podes mover'. ! !

!NoTePodesMoverError methodsFor: 'as yet unclassified' stamp: 'juan 11/19/2013 20:35'!
signal

"NoTePodesMoverError signal:'No te podes mover'." ! !
